# GCP - Secretmanager Post Exploitation

{{#include ../../../banners/hacktricks-training.md}}

## Secretmanager

For more information about Secret Manager check:

{{#ref}}
../gcp-services/gcp-secrets-manager-enum.md
{{#endref}}

### `secretmanager.versions.access`

Questo ti permette di leggere i secrets dal Secret Manager e potrebbe aiutare ad escalare i privilegi (a seconda delle informazioni memorizzate all'interno del secret):

<details>

<summary>Accedi alla versione del secret</summary>
```bash
# Get clear-text of version 1 of secret: "<secret name>"
gcloud secrets versions access 1 --secret="<secret_name>"
```
</details>

### `secretmanager.versions.destroy`
Il permesso `secretmanager.versions.destroy` consente a un'identità di distruggere permanentemente (contrassegnare come eliminata in modo irreversibile) una versione specifica di un secret in Secret Manager, il che potrebbe permettere la rimozione di credenziali critiche e potenzialmente causare denial of service o impedire il recupero di dati sensibili.
```bash
gcloud secrets versions destroy <VERSION> --secret="<SECRET_NAME>" --project=<PROJECTID>
```
### `secretmanager.versions.disable`
Il permesso `secretmanager.versions.disable` consente a un'identità di disabilitare versioni attive di secret in Secret Manager, bloccandone temporaneamente l'utilizzo da parte di applicazioni o servizi che ne dipendono.
```bash
gcloud secrets versions disable <VERSION> --secret="<SECRET_NAME>" --project=<PROJECTID>
```
### `secretmanager.secrets.delete`
Il set di permessi `secretmanager.secrets.delete` consente a un'identità di eliminare completamente un secret e tutte le sue versioni memorizzate in Secret Manager.
```bash
gcloud secrets delete <SECRET_NAME> --project=<PROJECT_ID>
```
### `secretmanager.secrets.update`
Il permesso `secretmanager.secrets.update` permette a un'identità di modificare i metadati e la configurazione di un secret (ad esempio, le impostazioni di rotazione, la policy di versione, le etichette e alcune proprietà del secret).
```bash
gcloud secrets update SECRET_NAME \
--project=PROJECT_ID \
--clear-labels \
--rotation-period=DURATION
```
{{#include ../../../banners/hacktricks-training.md}}
